/* qksort - sort array a (dimension n) using quicksort */
#include "local.h"
/* iqksort - internal function to partition a[lo:hi] */
static void iqksort(a, lo, hi)
	short a[];	/* array to be sorted; a[lo:hi]: multiset */
	index_t lo;	/* lowest subscript */
	index_t hi;	/* highest subscript */
	{
	index_t mid = lo + (hi-lo)/2;	/* : {lo:hi} */
	index_t i;						/* : {lo+1:hi+1} */
	index_t lastlo;					/* : {lo:hi-1} */
	short tmp;

	SWAP(a[lo], a[mid], tmp);
	lastlo = lo;
	for (i = lo + 1; i <= hi; ++i)
		{
		if (a[lo] > a[i])
			{
			++lastlo;
			SWAP(a[lastlo], a[i], tmp);
			}
		}
	SWAP(a[lo], a[lastlo], tmp);
	if (lastlo != 0 && lo < lastlo - 1)
		iqksort(a, lo, lastlo - 1);
	if (lastlo + 1 < hi)
		iqksort(a, lastlo + 1, hi);
	}
/* qksort - external entry point */
void qksort(a, n)
	short a[];	/* array to be sorted; a[0:n-1]: multiset */
	index_t n;	/* number of elements */
	{
	if (n > 1)
		iqksort(a, 0, n - 1);
	asserts(tst_sort(a, n), "a is sorted");
	}
